diff -N -U 5 -u openssh-4.2p1/sshhop.h sshop-4.2p1/sshhop.h
--- openssh-4.2p1/sshhop.h	Wed Dec 31 19:00:00 1969
+++ sshop-4.2p1/sshhop.h	Fri Oct 21 15:48:24 2005
@@ -0,0 +1,29 @@
+/*
+ * Copyright (c) 2005 Massachusetts Institute of Technology
+ *                    All rights reserved
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+#ifndef SSHHOP_H
+#define SSHHOP_H
+
+typedef void usage_fn(void);
+
+int  sshop_build_chain(char *ssh_path);
+void sshop_cleanup();
+int  sshop_kill_subprocesses();
+int  sshop_parse_options(int argc, char **argv, usage_fn *);
+void sshop_set_default_user(char *user);
+void sshop_wait_for_exit();
+
+#endif				/* SSHHOP_H */
diff -N -U 5 -u openssh-4.2p1/sshhop_test.c sshop-4.2p1/sshhop_test.c
--- openssh-4.2p1/sshhop_test.c	Wed Dec 31 19:00:00 1969
+++ sshop-4.2p1/sshhop_test.c	Mon Nov 28 13:18:07 2005
@@ -0,0 +1,119 @@
+/*
+ * Copyright (c) 2005 Massachusetts Institute of Technology
+ *                    All rights reserved
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include "includes.h"
+RCSID("$OpenBSD: readconf.c,v 1.137 2005/03/04 08:48:06 djm Exp $");
+
+#include <pwd.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include "log.h"
+#include "misc.h"
+#include "sshhop.h"
+#include "xmalloc.h"
+#include "ssh.h"
+#include "readconf.h"
+
+#undef  _PATH_SSH_PROGRAM
+#define _PATH_SSH_PROGRAM	"./ssh"
+
+Options options;
+int     debug_flag;
+
+/* !!!NOTE: Toy program -- no signal handlers !!!*/
+
+/* Prints a help message to the user.  This function never returns. */
+static void
+usage(void)
+{
+	fprintf(stderr,
+"usage: sshhop_test [ssh_options] -H [ssh_options] [-p port1] [user1@]host1\n"
+"                             ... -H [ssh_options] [-p portn] [usern@]hostn\n"
+"                   [command]\n"
+	);
+	exit(1);
+}
+
+/*
+ * Main for sshhop test program.
+ */
+int
+main(int argc, char *argv[])
+{
+	int hops;
+	int error;
+	int original_real_uid;
+	char *ssh_path = xstrdup(_PATH_SSH_PROGRAM);
+	struct passwd *pw;
+
+	/* May be enough arguments */
+	if (argc > 4) {
+		original_real_uid = getuid();
+		/* Get user data. */
+		pw = getpwuid(original_real_uid);
+		if (!pw) {
+			logit("You don't exist, go away!");
+			exit(1);
+		}
+		/* Take a copy of the returned structure. */
+		pw = pwcopy(pw);
+
+		hops = sshop_parse_options(argc, argv, usage);
+		/* No hosts given, exit after printing usage */
+		if (hops <= 0) {
+			usage();
+		}
+		/* Only one host, run the standard SSH.
+		 * Overwrite this process */
+		else if (hops == 1) {
+			argv[0] = ssh_path;
+			execv(argv[0], argv);
+		}
+		/* More than one hop, set up the hop chain */
+		else {
+			/*
+		 	* Initialize "log" output.  Since we are the client all output
+		 	* actually goes to stderr.
+		 	*/
+			log_init(argv[0],
+			    options.log_level == -1 ? SYSLOG_LEVEL_INFO : options.log_level,
+			    SYSLOG_FACILITY_USER, 1);
+
+			/* Make sure the user is set */
+			sshop_set_default_user(pw->pw_name);
+
+			/* Build the hop chain */
+			error = sshop_build_chain(ssh_path);
+
+			/* Hop chain established successfully, wait to clean
+			 * processes up.
+			 */
+			if (error == 0) {
+				sshop_wait_for_exit();
+			/* Things were not started properly, shutdown */
+			} else {
+				sshop_kill_subprocesses();
+				sshop_wait_for_exit();
+			}
+		}
+	/* Not enough arguments */
+	} else {
+		usage();
+	}
+	return(0);
+}
+
